#include <cmath>
#include <cstdlib>

#include "ball.h"

Ball::Ball(int _x, int _y, int _dir) {
	x = _x;
	y = _y;
	dir = _dir;
	speed = SSPEED;
}

void Ball::moveAlong(int maxX, int maxY) {
	x = int(x + speed * cos(-dir / DEG));
	y = int(y + speed * sin(-dir / DEG));
	
	checkBounce(maxX, maxY);
	
	if (x < BORDER) {
		x = BORDER + speed;
	} else if (x > maxX - BORDER) {
		x = maxX - BORDER - speed;
	}
	if (y < BORDER) {
		y = BORDER + speed;
	} else if (y > maxY - BORDER) {
		y = maxY - BORDER - speed;
	}
}

void Ball::checkBounce(int maxX, int maxY) {
	int oldDir = dir;
	
	if ((x - 15 < 0) || (x + 15 > maxX)) {
		dir = 180 - dir;
		if (dir < 0) {
			dir += 360;
		}
	}
	if ((y + 15 > maxY) || (y - 15 < 0)) {
		dir = 360 - dir;
	}
	
	if (oldDir != dir) {
        dir += rand()%91 - 45; //-45 to 45 degrees (no physical laws here...)
        if (dir < 0) {
			dir += 360;
		} else if (dir >= 360) {
			dir -=360;
		}
	}
}

void Ball::draw(QPainter& p) {
	p.setPen(QPen(Qt::blue, 1));
	p.setBrush(Qt::red);
	p.drawEllipse(x - 5, y - 5, 10, 10);
}

QPoint Ball::getPos() {
	return QPoint(x, y);
}

void Ball::setPos(QPoint newPos) {
	x = newPos.x();
	y = newPos.y();
}

void Ball::setSpeed(int _speed) {
	speed = _speed;
}
