#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QPolygon>
#include <QTimer>

#include "ball.h"
#include "pac.h"
#include "ui_mainwindow.h"

class MainWindow : public QMainWindow
{
	Q_OBJECT
public:
	MainWindow(QWidget * parent = 0);
public slots:
	void closeEvent(QCloseEvent* event);
	void resizeEvent(QResizeEvent* event);
	void paintEvent(QPaintEvent* event);
	void mousePressEvent(QMouseEvent* event);
	void timerCode();
private:
	Ui::MainWindow ui;
	QPolygon dots;
	QTimer * timer;
	Pac * pacMan;
	QVector<Ball *> balls;
	bool anim;
	int time, toptime, timerCount;
};

#endif
